

### All Types

| Name | Summary |
|---|---|
| [com.agoda.ninjato.Api](../com.agoda.ninjato/-api/index.md) | Main class of the library. Provides access to the DSL of call functions. |
| [com.agoda.ninjato.http.Body](../com.agoda.ninjato.http/-body/index.md) | Body entity of every [request](../com.agoda.ninjato.http/-request/index.md) and [response](../com.agoda.ninjato.http/-response/index.md). Stores the actual body value as [byte array](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-byte-array/index.html) but can transform it to [string](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html) and [stream](http://docs.oracle.com/javase/6/docs/api/java/io/InputStream.html) |
| [com.agoda.ninjato.converter.BodyConverter](../com.agoda.ninjato.converter/-body-converter/index.md) | Interface for converting instances of type `I` to type `O`. |
| [com.agoda.ninjato.dsl.Commons](../com.agoda.ninjato.dsl/-commons/index.md) | The main DSL entry of the library. |
| [com.agoda.ninjato.converter.ConverterFactories](../com.agoda.ninjato.converter/-converter-factories/index.md) | DSL context for aggregating [converter factories](../com.agoda.ninjato.converter/-body-converter/-factory/index.md). Supports additions of single factory and iterables of factories. |
| [com.agoda.ninjato.http.Cookies](../com.agoda.ninjato.http/-cookies/index.md) | DSL context for adding cookies to the headers of [request](../com.agoda.ninjato.http/-request/index.md). Supports addition of a single cookie with it's parameters. |
| [com.agoda.ninjato.policy.impl.DefaultRetryPolicy](../com.agoda.ninjato.policy.impl/-default-retry-policy/index.md) | Default implementation of [retry policy](../com.agoda.ninjato.policy/-retry-policy/index.md) bundled with the library. Keep note that this policy is `NOT` used by default and must be manually provided if needed. |
| [com.agoda.ninjato.policy.FallbackPolicy](../com.agoda.ninjato.policy/-fallback-policy/index.md) | Fallback policy. This policy gets invoked only if [retry policy](../com.agoda.ninjato.policy/-retry-policy/index.md)'s resolution was not [DoNotRetry](../com.agoda.ninjato.policy/-retry/-do-not-retry.md). |
| [com.agoda.ninjato.http.Headers](../com.agoda.ninjato.http/-headers/index.md) | DSL context for aggregating headers of [request](../com.agoda.ninjato.http/-request/index.md). Supports additions of single and iterable values of headers mapped to a key. |
| [com.agoda.ninjato.http.HttpClient](../com.agoda.ninjato.http/-http-client/index.md) | Abstraction of http client. Takes the top level in the cascade of [commons](../com.agoda.ninjato.dsl/-commons/index.md) DSL features. Executes generated requests[Request](../com.agoda.ninjato.http/-request/index.md) and returns [responses](../com.agoda.ninjato.http/-response/index.md) in synchronous manner. |
| [com.agoda.ninjato.exception.HttpException](../com.agoda.ninjato.exception/-http-exception/index.md) | This exception is thrown when [request](../com.agoda.ninjato.http/-request/index.md) returns error code and the inferred (request) return type is not [response](../com.agoda.ninjato.http/-response/index.md). |
| [com.agoda.ninjato.intercept.Interceptor](../com.agoda.ninjato.intercept/-interceptor/index.md) | Base interceptor interface that allows custom logic before [request](../com.agoda.ninjato.http/-request/index.md) is executed and after [response](../com.agoda.ninjato.http/-response/index.md) is retrieved. |
| [com.agoda.ninjato.intercept.Interceptors](../com.agoda.ninjato.intercept/-interceptors/index.md) | DSL context for aggregating [interceptors](../com.agoda.ninjato.intercept/-interceptor/index.md). Supports additions of single and arrays of request and response interceptors. |
| [com.agoda.ninjato.http.MediaType](../com.agoda.ninjato.http/-media-type/index.md) | Media type of the [request](../com.agoda.ninjato.http/-request/index.md) or [response](../com.agoda.ninjato.http/-response/index.md) body encoded in specified [charset](http://docs.oracle.com/javase/6/docs/api/java/nio/charset/Charset.html). |
| [com.agoda.ninjato.http.Method](../com.agoda.ninjato.http/-method/index.md) | Method of the http [request](../com.agoda.ninjato.http/-request/index.md). |
| [com.agoda.ninjato.exception.MissingBodyException](../com.agoda.ninjato.exception/-missing-body-exception/index.md) | This exception is thrown when [method](../com.agoda.ninjato.http/-method/index.md) of [request](../com.agoda.ninjato.http/-request/index.md) requires body to be present but cannot be found by the library. |
| [com.agoda.ninjato.exception.MissingConverterException](../com.agoda.ninjato.exception/-missing-converter-exception/index.md) | This exception is thrown when library cannot acquire [converter](../com.agoda.ninjato.converter/-body-converter/index.md) from the provided [factories](../com.agoda.ninjato.converter/-body-converter/-factory/index.md) and thus is unable to convert your provided value to [body](../com.agoda.ninjato.http/-body/index.md). |
| [com.agoda.ninjato.dsl.NinjatoDslMarker](../com.agoda.ninjato.dsl/-ninjato-dsl-marker/index.md) |  |
| [com.agoda.ninjato.http.Parameters](../com.agoda.ninjato.http/-parameters/index.md) | DSL context for aggregating query parameters of [request](../com.agoda.ninjato.http/-request/index.md). Supports additions of single value of parameter mapped to a key. |
| [com.agoda.ninjato.policy.Policy](../com.agoda.ninjato.policy/-policy/index.md) | Base policy interface that allows to apply custom strategies and decisions on retries and fallbacks. |
| [com.agoda.ninjato.http.Request](../com.agoda.ninjato.http/-request/index.md) | Base http entity of the library. Translates into the actual http request by [HttpClient](../com.agoda.ninjato.http/-http-client/index.md). |
| [com.agoda.ninjato.intercept.RequestInterceptor](../com.agoda.ninjato.intercept/-request-interceptor/index.md) | Base class for [request](../com.agoda.ninjato.http/-request/index.md) interceptors. |
| [com.agoda.ninjato.http.Response](../com.agoda.ninjato.http/-response/index.md) | Base http entity of the library. [HttpClient](../com.agoda.ninjato.http/-http-client/index.md) translates it's internal response entities into this one and propagates further. |
| [com.agoda.ninjato.intercept.ResponseInterceptor](../com.agoda.ninjato.intercept/-response-interceptor/index.md) | Base class for [response](../com.agoda.ninjato.http/-response/index.md) interceptors. |
| [com.agoda.ninjato.policy.Retry](../com.agoda.ninjato.policy/-retry/index.md) | Resolutions of the [retry policies](../com.agoda.ninjato.policy/-retry-policy/index.md) |
| [com.agoda.ninjato.policy.RetryPolicy](../com.agoda.ninjato.policy/-retry-policy/index.md) | Retry policy. This policy gets invoked when request has failed to complete successfully. |
| [com.agoda.ninjato.extension.Wrapper](../com.agoda.ninjato.extension/-wrapper/index.md) | This class allows contributors to write wrapper-like extension functions. |
